<?php
/************************************************************************/
/* XmlParser.class.php                                                  */
/* =====================================================================*/
/* Copyright (c) 2006 by Pentarh Udi  (pentarh at gmail dot com)        */
/*                                                                      */
/* Author(s): Pentarh Udi                                               */
/* =====================================================================*/
/* Title:  An Adult Empire XML parser Class                             */
/*   Date: March 7th, 2006                                              */
/*   Updated: April 23, 2007                                            */
/* =====================================================================*/
/* Credits:
         Thanks to Pupkin                                               
   USAGE:
   
   $ae=new AEXmlParser();
   
   $ae->Reset('amateur',462,30); // 462 - wm_id, 30 - number of links, 'amateur' - category name
   
   $ae->parseFeed();
   if ($ae->isError())
   {
    echo $ae->getError();
    exit();
   }
   //Whatever to do with associative array $ae->feed:
   print_r($ae->feed);

									*/
/* =====================================================================*/


class AEXmlParser
{
    // @ Variable Holding Parser
	var $SimpleParser;

	//@ Feed Source URL
	var $feedUrl_orig="http://www.adult-empire.com/feed.php?q=%s&aff=%u&num=%u";
	var $feedUrl_raw="http://www.adult-empire.com/feed.php?top=1&aff=%u&num=%u";
	var $feedUrl="";
	
	//@ Category Feed
	var $category_url="http://www.adult-empire.com/feed.php?help=1";
	var $category_parser;
	var $categories=array();
	var $xml_inside_row=false;
	var $xml_inside_results=false;
	var $xml_tag='';
	var $xml_row_counter=0;
	
	//@ Feed array
	var $feed = array();
	
	//@ Init errors
	var $init_error = false;
	var $error = false;
	var $error_string = '';
	
	//@ Cache
	var $cache_enabled=true;
	var $cache_time=3600;
	var $cache_dir='cache_query/';

	//@ Variables to Hold the Data
    var $inside_row = false;
    var $current_item = -1;
	var $tag = "";

	// Purpose : Constructor, Which will initialize the XML Parser
	function AEXmlParser($niche='',$aff_id='',$num_items='')
	{
		if (!extension_loaded('xml'))
		{
			$this->init_error=true;
			$this->setError('XML extension not found');
			return;
		}
		$this->Reset($niche,$aff_id,$num_items);
		return;
	}
	
	function cacheEnable($time,$dir)
	{
		$this->cache_enabled=true;
		$this->cache_dir=$dir;
		return ;
	}
	
	function cacheDisable()
	{
		$this->cache_enabled=false;
		return ;
	}
	
	function isInitError()
	{
		return $this->init_error;
	}
	
	function isError()
	{
		return $this->error || $this->init_error;
	}
	
	function getError()
	{
		if ($this->isError())
		{
			return $this->error_string;
		}
		return '';
	}
	
	function setError($str)
	{
		$this->error=true;
		$this->error_string=$str;
	}

	function Reset($niche,$aff_id,$num_items)
	{
		if ($this->isInitError())
		{
			return;
		}
		$this->error=false;
		$this->error_string='';
		if ($niche!='' && $aff_id!='' && $num_items>0)
		{
			$this->feedUrl=sprintf($this->feedUrl_orig,$niche,$aff_id,$num_items);
		}
		elseif ($aff_id!='' && $num_items>0)
		{
			$this->feedUrl=sprintf($this->feedUrl_raw,$aff_id,$num_items);
		}
		else
		{
			$this->feedUrl='';
		}
		
	    $this->SimpleParser = @xml_parser_create();
	    
	    if (!is_resource($this->SimpleParser))
	    {
   			$this->init_error=true;
			$this->setError("Error creating XML Parser resource");
	    	return;
	    }
        
		$this->feed=array();
		$this->inside_row=false;
		$this->current_item=-1;
		$this->tag='';
		
		xml_set_object($this->SimpleParser,$this);
		xml_set_element_handler($this->SimpleParser, "XmlParserFirstElement", "XmlParserendElement");
		xml_set_character_data_handler($this->SimpleParser, "characterData");
		
		return;
	}
	
	function XmlParserFirstElement($parser, $tagName, $attrs)
	{
		//echo "<{$tagName}>\n";
        //The Function Will be called, when ever the XML_PARSER Encounters a start Tag, in the XML File
		$this->tag = $tagName;
		if (!$this->inside_row && $tagName=='ROW')
		{
			$this->current_item++;
			$this->inside_row = true;
		}
	}

    function XmlParserendElement($parser, $tagName)
    {
		//echo "</{$tagName}>\n";
        //The Function Will be called, when ever the XML_PARSER Encounters a end Tag, in the XML File
		if ($tagName == "ROW" && $this->inside_row)
		{
			$this->inside_row = false;
		}
	}	
	
    //Function will be called by the Parser when the end tage of the element is processed. Requires Two Permeters
    function characterData($parser, $data)
    {
    	//echo $data;
        //Permeters: the parser instance and the string containing the data.
		if ($this->inside_row && $this->tag!='ROW')
		{
			if (!is_array($this->feed[$this->current_item]))
			{
				$this->feed[$this->current_item]=array();
			}
			if (!isset($this->feed[$this->current_item][strtolower($this->tag)]))
			{
				$this->feed[$this->current_item][strtolower($this->tag)]='';
			}
			$this->feed[$this->current_item][strtolower($this->tag)].=stripcslashes($data);
		}
	}

	function getFeedUrl($url)
	{
		//Get feed URL either from cache or from URL, return file pointer
		$cache=false;
		if ($this->cache_enabled && is_dir($this->cache_dir))
		{
			//Check cached query
			$hash=md5($url);
			if (file_exists($this->cache_dir.$hash))
			{
				if (filemtime($this->cache_dir.$hash) > time() - $this->cache_time)
				{
					//echo "Found cache. ";
					$cache=true;
				}
			}
		}
		
		if (!$cache && $this->cache_enabled && is_dir($this->cache_dir) && is_writable($this->cache_dir))
		{
			//echo "Cache not found, creating. ";
			$fp = @fopen($url,"r");
			$fp1 = @fopen($this->cache_dir.$hash,'w');
			if (is_resource($fp) && is_resource($fp1))
			{
				while ($buf=fread($fp,4096))
				{
					fwrite($fp1,$buf);
				}
				fclose($fp);
				fclose($fp1);
				$cache=true;
			}
			else
			{
				if (!is_resource($fp))
				{
					trigger_error("Can't open feed URL: ".$url,E_USER_WARNING);
				}
				if (!is_resource($fp1))
				{
					trigger_error("Can't create cache file: ".$this->cache_dir.$hash,E_USER_WARNING);
				}
			}
		}
		
		if ($cache)
		{
			//echo "Getting feed from cache.";
			$fp=@fopen($this->cache_dir.$hash,'r');
			if (!is_resource($fp))
			{
				trigger_error("Can't open cache file: ".$this->cache_dir.$hash,E_USER_WARNING);
			}
		}
		else
		{
			if ($this->cache_enabled)
			{
				echo "<b>Caching query failed. Check valid permissions on 'cache_query' folder (777)</b><br><br>";
			}
			$fp = @fopen($url,"r");
			if (!is_resource($fp))
			{
				trigger_error("Can't open feed URL: ".$url,E_USER_WARNING);
			}
		}
		
		if (is_resource($fp))
		{
			return $fp;
		}
		return false;
	}
	
	function catXmlParserFirstElement($parser, $tagName, $attrs)
	{
		$this->xml_tag = $tagName;
		if ($this->xml_tag=='RESULTS' && !$this->xml_inside_results)
		{
			$this->xml_inside_results=true;
		}
		if ($this->xml_tag=='ROW' && $this->xml_inside_results && !$this->xml_inside_row)
		{
			$this->xml_inside_row=true;
		}
	}
	
	function catXmlParserendElement($parser, $tagName)
	{
		if ($tagName=='RESULTS' && $this->xml_inside_results)
		{
			$this->xml_inside_results=false;
			$this->xml_inside_row=false;
		}
		if ($tagName=='ROW' && $this->xml_inside_results && $this->xml_inside_row)
		{
			$this->xml_inside_row=false;
			$this->xml_row_counter++;
		}
	}
	
	function catcharacterData($parser, $data)
	{
		if ($this->xml_inside_results && $this->xml_inside_row)
		{
			switch ($this->xml_tag)
			{
				case 'NAME':
				case 'DESCRIPTION':
				case 'URL':
					$key=strtolower($this->xml_tag);
					if (!is_array($this->categories[$this->xml_row_counter]))
					{
						$this->categories[$this->xml_row_counter]=array();
					}
					$this->categories[$this->xml_row_counter][$key].=stripcslashes($data);
					break;
			
				default:
					break;
			}
		}
	}
	
	function getCategories()
	{
	    $this->category_parser = @xml_parser_create();
	    
	    if (!is_resource($this->category_parser))
	    {
   			$this->init_error=true;
			$this->setError("Error creating XML Parser resource");
	    	return;
	    }
		$this->categories=array();
		$this->xml_inside_row=false;
		$this->xml_inside_results=false;
		$this->xml_tag='';
		$this->xml_row_counter=0;

        
		xml_set_object($this->category_parser,$this);
		xml_set_element_handler($this->category_parser, "catXmlParserFirstElement", "catXmlParserendElement");
		xml_set_character_data_handler($this->category_parser, "catcharacterData");
		
		$fp=$this->getFeedUrl($this->category_url);
		if (!is_resource($fp))
		{
			xml_parser_free($this->SimpleParser);
			$this->setError("Can't open feed");
			return;
		}
        $content='';
		while ($data = fread($fp, 4096))
		{
			$content.=$data;
			if (!@xml_parse($this->category_parser, $data, feof($fp)))
			{
				@fclose($fp);
				$err=xml_get_error_code($this->category_parser);
				xml_parser_free($this->category_parser);
				$this->setError("XML ERROR [{$err}]: ".xml_error_string($err));
				return;
			}
		}
		fclose($fp);
		
		if (is_array($this->categories))
		{
			for (reset($this->categories); list($idx,$arr)=each($this->categories);)
			{
				if (is_array($arr))
				{
					for (reset($arr); list($k,$v)=each($arr);)
					{
						$this->categories[$idx][$k]=trim($v);
					}
				}
			}
			reset($this->categories);
		}
		
		return ;
	}
	
	function parseFeed()
	{
		if ($this->isInitError())
		{
			return;
		}

		if ($this->feedUrl == '')
		{
			$this->setError("Feed parameters are not set");
			return;
		}
		
		$fp=$this->getFeedUrl($this->feedUrl);
		
		if (!is_resource($fp))
		{
			xml_parser_free($this->SimpleParser);
			$this->setError("Can't open feed");
			return;
		}

        //Starts reading the contents of the file, 4K at a time, and put it in the variable "$data"
        $content='';
		while ($data = fread($fp, 4096))
		{
			$content.=$data;
			if (!@xml_parse($this->SimpleParser, $data, feof($fp)))
			{
				@fclose($fp);
				$err=xml_get_error_code($this->SimpleParser);
				xml_parser_free($this->SimpleParser);
				$this->setError("XML ERROR [{$err}]: ".xml_error_string($err));
				return;
			}
		}
		
        //Perform Some Clean Up Work Before Closing the File.
        //Closing the XML File
        fclose($fp);
        //Release the XML Parser
        xml_parser_free($this->SimpleParser);
        
        // Total trim
        if (is_array($this->feed))
        {
        	for (reset($this->feed); list($idx,$arr)=each($this->feed);)
        	{
        		for (reset($arr); list($arr_key,$arr_val)=each($arr);)
        		{
        			$this->feed[$idx][$arr_key]=trim($arr_val);
        		}
        		if (preg_match('#site_id=([0-9]+)#i',$arr['url'],$regs))
        			$this->feed[$idx]['id']=intval($regs[1]);
        	}
        	reset($this->feed);
        }
        return;
	}
}	
?>