<?
require_once('smarty/Smarty.class.php');
require_once('aexmlparser.php');
require_once('config.php');

function getList($category,$aff_id,$num_links,$template)
{
	$template=ereg_replace('[/\\]+','',$template);
	if (!file_exists("template/{$template}.tpl"))
	{
		trigger_error("Template 'template/{$template}.tpl' not found",E_USER_WARNING);
		echo "Template 'template/{$template}.tpl' not found";
		return ;
	}
	$parser=new AEXmlParser($category,$aff_id,$num_links);
	if ($parser->isError())
	{
		trigger_error("Parser error: ".$parser->getError(),E_USER_WARNING);
		echo "Parser error: ".$parser->getError();
		return ;
	}

	$smarty=new Smarty();
	$smarty->template_dir='template';
	$smarty->compile_dir='template/compile';
	$parser->cacheEnable($GLOBALS['cfg']['cache_xml_time'],'cache_query/');

	$parser->parseFeed();
	
	if ($parser->isError())
	{
		trigger_error("Parser error: ".$parser->getError(),E_USER_WARNING);
		echo "Parser error: ".$parser->getError();
		return ;
	}
	
	//Thumbs URL fix
	for (reset($parser->feed);list($idx,$site)=each($parser->feed);)
	{
		for (reset($site);list($k,$v)=each($site);)
		{
			if (preg_match('#adult\-empire\.com/([a-z0-9_\-]+/[a-zA-Z0-9_\-]+\.jpg)$#i',$v,$regs))
			{
				$parser->feed[$idx][$k]=$GLOBALS['cfg']['app_url'].'cache_thumbs/'.$regs[1];
			}
		}
	}
	
	
	$smarty->assign_by_ref('feed',$parser->feed);
	
	$parser->getCategories();
	
	if ($parser->isError())
	{
		trigger_error("Parser error: ".$parser->getError(),E_USER_WARNING);
		echo "Parser error: ".$parser->getError();
		return ;
	}

	//Category URL fix
	$cat_info=array();
	for (reset($parser->categories);list($idx,$cat)=each($parser->categories);)
	{
		$parser->categories[$idx]['url']=$GLOBALS['cfg']['app_url'].'category.php?category='.rawurlencode($cat['name']);
		if ($category!='')
		{
			if ($cat['name'] == $category)
			{
				$cat_info=$cat;
			}
		}
	}
	
	$smarty->assign_by_ref('categories',$parser->categories);
	
	if ($category!='')
	{
		$smarty->assign_by_ref('category',$cat_info);
	}
	
	return $smarty->fetch($template.'.tpl');
}

?>